-- MixScript, pro Gentles Limited camera remote control
-- The Gentles 181 gives you advanced control of Sony Multi cameras and camcorders from your PWM Radio Control (RC) system.
---
-- movie on -50% až -100%
-- focus on +50%
-- shutter +95% - +100%
--
-- jednotlivé hranice sepnutí se nastavují přes lokální proměnné - vstupů je málo, tak max něco málo jako parametr skriptu
-- další lokální proměnné nastaví
--
-- použiju časovač
-- CamCtrl  - 3 polohový vypínač, který určuje činnost
-- PicFreq  - potenciometr, který určí rychlost snímání v rozsahu "strašně rychle" až T-max
-- T-max    - maximální čas, který lze nastavit potenciometrem std max ~10s
-- Focus tm   - délka ostření v 0,01 s std 100 (1s)
-- Focus lv   - uroven focusu v %
--
-- jako parametr asi bude dobré dát
local input = {
    {"CamCtrl", SOURCE}, -- vypínač
    {"PicFreq", SOURCE}, -- potenciometr
    {"T-Max", VALUE, 0, 60, 10},
    {"Focus tm", VALUE, 0, 200, 100},
    { "Focus lv", VALUE, 0, 100, 40}
}

local output = {"Cam"}

local cameraLevel = -1024 -- úroveň kdy bude sepnutý režim kamery
--local focusLevel = 410 -- úroveň kdy bude namáčknutá spoušť - zaostřuje se
local shutterLevel = 1024 -- úroveň kdy bude pořízen snímek

-- local focusDelay = 100   -- v setinách sekundy
local shutterDelay = 20

local retval = 0
local lastTm
local status = 0 -- 0 -idle, 1 - camera, 2 - focus, 3-shutter, 4-release -- čísla místo textu kvůli výkonu (kdo by porovnával stringy, žejo)
--  -- camera je asi zbytečný stav.
local repeatAfter

local function init_func()
    lastTm = getTime()
end

local function run_func(switch, pot, tmax, focusDelay, fLevel)
    retval = 0

    if (switch < -1000 and status == 0) then
        retval = cameraLevel
    elseif (switch > 1000 or status > 0) then
        -- řešení pořizování fotek
        -- napřed hned zaostřím, pak cvaknu snímek a uvolním. Po navoleném čase znovu. Nebudu hlídat jak rychle je nastavené cvakání,
        -- celkový čas bude hlídaný a nebude se hledět, jestli není kratší jak focus + shutter
        if (status == 0) then
            status = 2
            lastTm = getTime()
        end

        if (status == 2) then -- focus
            retval = fLevel * 10.24
            if (lastTm + focusDelay < getTime()) then
                status = 3
            end
        end

        if (status == 3) then -- shutter
            retval = shutterLevel
            if (lastTm + focusDelay + shutterDelay < getTime()) then
                status = 4
            end
        end

        if (status == 4) then -- release, čekání na časovač, kdy se spustí další cyklus
            retval = 0
            -- spocitam si cas
            repeatAfter = tmax * 100 * (pot + 1100)/2048

            if ((lastTm + repeatAfter < getTime()) or switch < 1000) then
                status = 0
                lastTm = getTime()
            end
        end
    else
        status = 0
        retval = 0
    end

    return retval
end

return {input = input, output = output, run = run_func, init = init_func}
